package it.cavallium;

import com.google.i18n.phonenumbers.Phonenumber.PhoneNumber;
import it.tdlight.tdlibsession.td.easy.AsyncTdEasy;
import java.util.Set;
import java.util.function.BiFunction;
import java.util.function.Function;
import java.util.function.Supplier;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

public interface TransferService {

	void setApiId(int apiId);

	void setApiHash(String apiHash);

	Mono<AddUserBotResult> addUserbot(PhoneNumber phoneNumber,
			Function<AsyncTdEasy, Mono<Integer>> codeSupplier,
			BiFunction<AsyncTdEasy, String, Mono<String>> otpSupplier,
			Supplier<Mono<Void>> onUserbotClosed);

	Mono<Void> quit();

	Mono<Void> closeUserbot(PhoneNumber phoneNumber);

	Set<PhoneNumber> getPhoneNumbers();

	Set<BaseChatInfo> getAdminSupergroups(boolean canRestrictMembers, boolean canInviteUsers);

	Flux<ItemUpdate<SupergroupInfo>> subscribeAdminSupergroups();

	Mono<Void> transferMembers(BaseChatInfo sourceGroup,
			BaseChatInfo destGroup,
			Function<UserStatus, Mono<Void>> userStatusConsumer,
			Function<Integer, Mono<Void>> percentageConsumer,
			Function<String, Mono<Void>> phaseDescriptionConsumer);
}
